"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ConcatAsyncIterable = void 0;
const tslib_1 = require("tslib");
const common_1 = require("../common");
/* @internal */
class ConcatAsyncIterable {
    constructor(xs, ys) {
        this.xs = xs;
        this.ys = ys;
    }
    [Symbol.asyncIterator]() {
        return concatItersAsync(this.xs, this.ys);
    }
}
exports.ConcatAsyncIterable = ConcatAsyncIterable;
function concatItersAsync(xs, ys) {
    return tslib_1.__asyncGenerator(this, arguments, function* concatItersAsync_1() {
        var e_1, _a;
        yield tslib_1.__await(yield* tslib_1.__asyncDelegator(tslib_1.__asyncValues(xs)));
        if (common_1.isIterable(ys)) {
            for (const y of ys) {
                yield yield tslib_1.__await(y);
            }
        }
        else {
            try {
                for (var ys_1 = tslib_1.__asyncValues(ys), ys_1_1; ys_1_1 = yield tslib_1.__await(ys_1.next()), !ys_1_1.done;) {
                    const y = ys_1_1.value;
                    yield yield tslib_1.__await(y);
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (ys_1_1 && !ys_1_1.done && (_a = ys_1.return)) yield tslib_1.__await(_a.call(ys_1));
                }
                finally { if (e_1) throw e_1.error; }
            }
        }
    });
}
