"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.IntercalateAsyncIterable = exports.IntersperseAsyncIterable = void 0;
const tslib_1 = require("tslib");
/* @internal */
class IntersperseAsyncIterable {
    constructor(xs, sep) {
        this.xs = xs;
        this.sep = sep;
    }
    [Symbol.asyncIterator]() {
        return intersperseAsync(this.xs, this.sep);
    }
}
exports.IntersperseAsyncIterable = IntersperseAsyncIterable;
/* @internal */
class IntercalateAsyncIterable {
    constructor(xs, sep) {
        this.xs = xs;
        this.sep = sep;
    }
    [Symbol.asyncIterator]() {
        return intercalateAsync(this.xs, this.sep);
    }
}
exports.IntercalateAsyncIterable = IntercalateAsyncIterable;
function intersperseAsync(it, sep) {
    return tslib_1.__asyncGenerator(this, arguments, function* intersperseAsync_1() {
        var e_1, _a;
        let first = true;
        try {
            for (var it_1 = tslib_1.__asyncValues(it), it_1_1; it_1_1 = yield tslib_1.__await(it_1.next()), !it_1_1.done;) {
                const x = it_1_1.value;
                if (!first) {
                    yield yield tslib_1.__await(sep);
                }
                yield yield tslib_1.__await(x);
                first = false;
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (it_1_1 && !it_1_1.done && (_a = it_1.return)) yield tslib_1.__await(_a.call(it_1));
            }
            finally { if (e_1) throw e_1.error; }
        }
    });
}
function intercalateAsync(it, sep) {
    return tslib_1.__asyncGenerator(this, arguments, function* intercalateAsync_1() {
        var e_2, _a;
        let first = true;
        try {
            for (var it_2 = tslib_1.__asyncValues(it), it_2_1; it_2_1 = yield tslib_1.__await(it_2.next()), !it_2_1.done;) {
                const x = it_2_1.value;
                if (!first) {
                    for (const y of sep) {
                        yield yield tslib_1.__await(y);
                    }
                }
                yield yield tslib_1.__await(x);
                first = false;
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (it_2_1 && !it_2_1.done && (_a = it_2.return)) yield tslib_1.__await(_a.call(it_2));
            }
            finally { if (e_2) throw e_2.error; }
        }
    });
}
