"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AsyncFromIterable = exports.IterateAsyncIterable = void 0;
const tslib_1 = require("tslib");
/* @internal */
class IterateAsyncIterable {
    constructor(f, x) {
        this.f = f;
        this.x = x;
    }
    [Symbol.asyncIterator]() {
        return iterateAsync(this.f, this.x);
    }
}
exports.IterateAsyncIterable = IterateAsyncIterable;
/* @internal */
class AsyncFromIterable {
    constructor(xs) {
        this.xs = xs;
    }
    [Symbol.asyncIterator]() {
        return fromIterableAsync(this.xs);
    }
}
exports.AsyncFromIterable = AsyncFromIterable;
function iterateAsync(f, x) {
    return tslib_1.__asyncGenerator(this, arguments, function* iterateAsync_1() {
        while (true) {
            yield yield tslib_1.__await(x);
            x = yield tslib_1.__await(f(x));
        }
    });
}
function fromIterableAsync(xs) {
    return tslib_1.__asyncGenerator(this, arguments, function* fromIterableAsync_1() {
        for (const x of xs) {
            yield yield tslib_1.__await(yield tslib_1.__await(x));
        }
    });
}
