"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TakeWhileAsyncIterable = exports.TakeAsyncIterable = void 0;
const tslib_1 = require("tslib");
/* @internal */
class TakeAsyncIterable {
    constructor(n, xs) {
        this.n = n;
        this.xs = xs;
    }
    [Symbol.asyncIterator]() {
        return takeAsync(this.n, this.xs);
    }
}
exports.TakeAsyncIterable = TakeAsyncIterable;
/* @internal */
class TakeWhileAsyncIterable {
    constructor(p, xs) {
        this.p = p;
        this.xs = xs;
    }
    [Symbol.asyncIterator]() {
        return takeWhileAsync(this.p, this.xs);
    }
}
exports.TakeWhileAsyncIterable = TakeWhileAsyncIterable;
function takeAsync(n, xs) {
    return tslib_1.__asyncGenerator(this, arguments, function* takeAsync_1() {
        var e_1, _a;
        try {
            for (var xs_1 = tslib_1.__asyncValues(xs), xs_1_1; xs_1_1 = yield tslib_1.__await(xs_1.next()), !xs_1_1.done;) {
                const x = xs_1_1.value;
                if (n <= 0) {
                    return yield tslib_1.__await(void 0);
                }
                yield yield tslib_1.__await(x);
                --n;
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (xs_1_1 && !xs_1_1.done && (_a = xs_1.return)) yield tslib_1.__await(_a.call(xs_1));
            }
            finally { if (e_1) throw e_1.error; }
        }
    });
}
function takeWhileAsync(f, xs) {
    return tslib_1.__asyncGenerator(this, arguments, function* takeWhileAsync_1() {
        var e_2, _a;
        try {
            for (var xs_2 = tslib_1.__asyncValues(xs), xs_2_1; xs_2_1 = yield tslib_1.__await(xs_2.next()), !xs_2_1.done;) {
                const x = xs_2_1.value;
                if (f(x)) {
                    yield yield tslib_1.__await(x);
                }
                else {
                    return yield tslib_1.__await(void 0);
                }
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (xs_2_1 && !xs_2_1.done && (_a = xs_2.return)) yield tslib_1.__await(_a.call(xs_2));
            }
            finally { if (e_2) throw e_2.error; }
        }
    });
}
