"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.IntercalateIterable = exports.IntersperseIterable = void 0;
/* @internal */
class IntersperseIterable {
    constructor(xs, sep) {
        this.xs = xs;
        this.sep = sep;
    }
    [Symbol.iterator]() {
        return intersperse(this.xs, this.sep);
    }
}
exports.IntersperseIterable = IntersperseIterable;
/* @internal */
class IntercalateIterable {
    constructor(xs, sep) {
        this.xs = xs;
        this.sep = sep;
    }
    [Symbol.iterator]() {
        return intercalate(this.xs, this.sep);
    }
}
exports.IntercalateIterable = IntercalateIterable;
function* intersperse(it, sep) {
    let first = true;
    for (const x of it) {
        if (!first) {
            yield sep;
        }
        yield x;
        first = false;
    }
}
function* intercalate(it, sep) {
    let first = true;
    for (const x of it) {
        if (!first) {
            for (const y of sep) {
                yield y;
            }
        }
        yield x;
        first = false;
    }
}
