"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TakeWhileIterable = exports.TakeIterable = void 0;
/* @internal */
class TakeIterable {
    constructor(n, xs) {
        this.n = n;
        this.xs = xs;
    }
    [Symbol.iterator]() {
        return take(this.n, this.xs);
    }
}
exports.TakeIterable = TakeIterable;
/* @internal */
class TakeWhileIterable {
    constructor(p, xs) {
        this.p = p;
        this.xs = xs;
    }
    [Symbol.iterator]() {
        return takeWhile(this.p, this.xs);
    }
}
exports.TakeWhileIterable = TakeWhileIterable;
function* take(n, xs) {
    for (const x of xs) {
        if (n <= 0) {
            return;
        }
        yield x;
        --n;
    }
}
function* takeWhile(f, xs) {
    for (const x of xs) {
        if (f(x)) {
            yield x;
        }
        else {
            return;
        }
    }
}
